
import numpy as np


def Reward(n, N, S):
    reward = 0
    r = 0
    if n < N-1:
        reward = 0
    if n == N-1:
        for m in range(2, N):
            current_position = S[m]
            for surround_position in ([current_position[0] - 1, current_position[1]],
                                      [current_position[0], current_position[1] + 1],
                                      [current_position[0] + 1, current_position[1]],
                                      [current_position[0], current_position[1] - 1]):
                if surround_position in S[0:m - 1]:
                    k = S.index(surround_position)
                    if sequence[k] == 0 and sequence[m] == 0:
                        r += 1
        reward = r
    return reward, r

def calculate_position(last_position, current_position, current_action_index):
    actions = np.array([[[0, 1],
                        [-1, 0]],
                        [[1, 0],
                        [0, 1]],
                        [[0, -1],
                        [1, 0]]])
    current_action = np.dot((np.array(current_position)-np.array(last_position)), actions[current_action_index])
    return current_action

def get_actions(last_position,current_position):
    actions_matrix = np.array([[[0, 1],
                               [-1, 0]],
                               [[1, 0],
                               [0, 1]],
                               [[0, -1],
                               [1, 0]]])
    actions = [list(np.dot((np.array(current_position) - np.array(last_position)), x))
               for x in actions_matrix]
    return actions


def oneepisode(is_train):
    S = [[N-1, N-1]]
    A = [[1, 0]]
    checkstate = np.zeros((2*N-1, 2*N-1))
    checkstate[N-1, N-1] = 1
    start_position = [N, N-1]
    current_position = start_position
    current_state = 1
    checkstate[current_position[0], current_position[1]] = 1
    S.append(current_position)

    next_position = [0, 0]
    n = 2
    r = 0

    while n <= N - 1:
        m = 0
        if is_train:
            if np.random.binomial(1, epsilon) == 1:
                actions = get_actions(S[-2], S[-1])
                current_action = actions[np.random.randint(0, 3, size=(1,))[0]]
            else:
                actions = get_actions(S[-2], S[-1])
                current_action = actions[np.argmax(stateactionvalue[current_state-1, :])]
        else:
            actions = get_actions(S[-2], S[-1])
            current_action = actions[np.argmax(stateactionvalue[current_state-1, :])]

        next_state = state_transfer[current_state-1, actions.index(current_action)]

        next_position[0] = current_position[0] + current_action[0]
        next_position[1] = current_position[1] + current_action[1]

        if is_train:
            while checkstate[next_position[0], next_position[1]] == 1:
                if np.random.binomial(1, epsilon) == 1:
                    actions = get_actions(S[-2], S[-1])
                    current_action = actions[np.random.randint(0, 3, size=(1,))[0]]
                else:
                    actions = get_actions(S[-2], S[-1])
                    current_action = actions[np.argmax(stateactionvalue[current_state - 1, :])]

                next_position[0] = current_position[0] + current_action[0]
                next_position[1] = current_position[1] + current_action[1]
                next_state = state_transfer[current_state - 1, actions.index(current_action)]
                m += 1
                if m > 30:
                    break
        if m > 30:
            return S, A, r

        next_actions = get_actions(S[-1], next_position)
        next_action = next_actions[np.argmax(stateactionvalue[next_state-1, :])]

        S.append(next_position.copy())

        reward, r = Reward(n, N, S)
        if is_train:
            stateactionvalue[current_state-1, actions.index(current_action)] += \
             alpha * (reward + gamma * stateactionvalue[next_state-1, next_actions.index(next_action)]
                 - stateactionvalue[current_state-1, actions.index(current_action)])

        checkstate[next_position[0], next_position[1]] = 1
        current_position = next_position.copy()
        current_state = next_state
        A.append(current_action.copy())
        n += 1

    return S, A, r

if __name__ == "__main__":
    #  sequence4 = [H, H, P, H, P, P, H, P, H, P, H, H, P, H]  # CHANGE HP SEQUENCE HERE H--0, P--1
    sequence = [0, 0, 1, 0, 1, 1, 0, 1, 0, 1, 0, 0, 1, 0]
    N = len(sequence)

    state_num = 0
    state_num = np.int((3 ** (N-1) - 1) / 2)

    state_transfer = np.array(range(2, state_num + 1))
    state_transfer = state_transfer.reshape((-1, 3))

    stateactionvalue = np.zeros((state_num, 3))

    alpha = 0.01
    epsilon = 0.5
    gamma = 0.9

    Iteration = 5000000
    it = 1
    r = 0
    r_list = []
    r_min = 0

    while it <= Iteration:
        oneepisode(True)
        if it % 10000 == 0:
            S, A, r = oneepisode(False)
            if r > r_min:
                r_min = r
                print('find lower energy !', -r, '\n', S)
            print(it, '/', Iteration, 'r=', -r)
        it += 1

    print('test\n')
    S, A, r = oneepisode(False)
    print('The lowest energy：', -r, '\n')
    print('Two-dimensional coordinate set S：', S, '\n')
    print('Action set A: ', A, '\n')




